# **INFO PROJECT**

HOW TO START AND CREATE A WEB WITH DJANGO

- [**INFO PROJECT**](#info-project)
- [**Set up**](#set-up)
  - [**GET LIBERIES AND VIRTUAL ENVIROMENT**](#get-liberies-and-virtual-enviroment)
- [**DJANGO GUIDE**](#django-guide)
  - [**CREATE WEB**](#create-web)
  - [**START PROJECT**](#start-project)
  - [**COMMANDS**](#commands)
  - [**STRUCTURE**](#structure)
  - [**Server port setting**](#server-port-setting)
  - [**App content directory**](#app-content-directory)

# **Set up**

Steps to execute o create enviromento to execute o mount proyect

## **GET LIBERIES AND VIRTUAL ENVIROMENT**

Recommen to create a virutal enviroment

Virtual Enviroment
1 - Open a terminal and go folder (directory) we use as root for our projects

>cd "D:\XXX\XXX\WebTutorial"

2 - Create a virtual environment called "NAMEHERE"

>python -m venv env   or  python -m venv "NAMEHERE"

3 - Check virtual if in  virutal enviroment "NAMEHERE"

>which python

4 - Activate virtual environment called "NAMEHERE"

>cd "D:\XXX\XXX\NAMEHERE\Scripts
>activate

5 - Deactivate the virtual environment "NAMEHERE"

>cd "D:\XXX\XXX\NAMEHERE\Scripts
>deactivate

If u created and virtual enviroment or not to get all the libreries u need to execute
>pip install requirements.txt

And if you added more libreries  you need to execute
>pip freeze > requirements.txt
in the same place where requirements.txt are

# **DJANGO GUIDE**

## **CREATE WEB**

To create a new project u need to go to root folder and execute

django-admin startproject NAMEPROJECT

python3 manage.py runserver

then execute cd .\NAMEPROJECT\

## **START PROJECT**

From root folder execute
>cd .\WebTutorial\WebTutorial\
>py manage.py runserver
With this the server web its alive

## **COMMANDS**

The commands are supplied as an argument to this script; for example, if we say to run the 
>manage.py runserver command
we would mean running the manage.py script like this:
>py manage.py ***

runserver: Starts the Django development HTTP server, to serve your Django app on your local computer.

startapp: Creates a new Django app in your project. We'll talk about what apps are in more depth soon.

shell: Starts a Python interpreter with the Django settings pre-loaded. This is useful for interacting with your application without having to manually load in your Django settings.

dbshell:Starts an interactive shell connected to your database, using the default parameters from your Django settings.</br> 
You can run manual SQL queries in this way.

makemigrations: Generate database change instructions from your model definitions.

migrate: Applies migrations generated by the makemigrations command.

test: Run automated tests that you have written.

## **STRUCTURE**

The myproject Directory
Moving on from the manage.py file, the other file item created by startproject
is the myproject directory. This is the actual Python package for your project. It
contains settings for the project, some configuration files for your web server, and the
global URL maps. Inside the myproject directory are five files:
<ol>
  <li>__init__.py</li>
  <li>asgi.py</li>
  <li>urls.py</li>
  <li>wsgi.py</li>
</ol>

**__init__.py**
An empty file that lets Python know that the myproject directory is a Python module. You'll be familiar with these files if you've worked with Python before.

**settings.py**
This contains all the Django settings for your application. We will explain the contents soon.

**urls.py**
This has the global URL mappings that Django will initially use to locate views or other child URL mappings.

**asgi.py and wsgi.py**
These files are what ASGI or WSGI web servers use to communicate with your Django app when you deploy it to a production web server. You normally don't need to edit these at all, and they aren't used in day-to-day development.

## **Server port setting**

By default, the server listens on port 8000 on localhost (127.0.0.1), but this can be changed by adding a port number or address and port number after the runserver argument:

>py manage.py runserver 8001

This will have the server listen on port 8001 on localhost (127.0.0.1).
You can also have it listen on a specific address if your computer has more than one, or 0.0.0.0 for all addresses:

>py manage.py runserver 0.0.0.0:800

## **App content directory**

**__init__.py**: An empty file indicating that this directory is a Python module.

**admin.py**: Django has a built-in admin site for viewing and editing data with a Graphical User Interface (GUI). In this file, you will define how your app's models are exposed in the Django admin site.

**apps.py**: This contains some configuration for the metadata of your app. You
won't need to edit this file.

**models.py**: This is where you will define the models for your application.

**migrations**: Django uses migration files to automatically record changes to your underlying database as the models change. They are generated by Django when you run the manage.py makemigrations command and are stored in this directory. They do not get applied to the database until you run manage.py migrate.

**tests.py**: To test that your code is behaving correctly, Django supports writing tests (unit, functional, or integration) and will look for them inside this file.

**views.py**: Your Django views (the code that responds to HTTP requests) will go in here.
